import React, { Component } from 'react';
import PropTypes from 'prop-types';
import hoistStatics from 'hoist-non-react-statics';
import { getDisplayName } from 'next-server/dist/lib/utils';
export default function withRouter(ComposedComponent) {
    const displayName = getDisplayName(ComposedComponent);
    class WithRouteWrapper extends Component {
        render() {
            return React.createElement(ComposedComponent, Object.assign({ router: this.context.router }, this.props));
        }
    }
    WithRouteWrapper.contextTypes = {
        router: PropTypes.object
    };
    WithRouteWrapper.displayName = `withRouter(${displayName})`;
    return hoistStatics(WithRouteWrapper, ComposedComponent);
}
